//+------------------------------------------------------------------+
//|                                                           MA.mq4 |
//|                                                          maia666 |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "maia666"
#property link      ""
#property version   "1.00"
#property strict
#property indicator_chart_window
#property indicator_buffers 4
#property indicator_color1 Yellow
#property indicator_color2 Yellow
double Buf_0[],Buf_1[],Buf_2[],Buf_3[]; //    

extern int PerMa1=12;
extern int PerMa2=20;
extern int DayAnaliz=6;
extern bool PerM5=true;
extern int ProcentBuy=70;
extern int ProcentSell=30;
extern int ma_shift=0;
extern int ma_method=0;
extern string applied_price="PRICE_CLOSE";

string PerTF=""; //       
string PerTFm=""; //       
datetime TFSek=0;
double KolVoSimVal=0;
int Kotirovka=0;
datetime Sutki=86400;
int SistemPerFor=0;
int TekTF=0;
bool newbar = false;
datetime nullbar = TimeCurrent();
bool vishemast = true; //  .   
bool nigemast = true; //  . 
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit()
  {
//--- indicator buffers mapping
IndicatorDigits(MarketInfo(Symbol(),MODE_DIGITS));
SetIndexBuffer (0,Buf_0);
SetIndexStyle (0,DRAW_LINE,STYLE_DOT,1);
SetIndexBuffer (1,Buf_1);
SetIndexStyle (1,DRAW_LINE,STYLE_SOLID,2);
SetIndexBuffer (2,Buf_2);
//SetIndexStyle (0,DRAW_LINE,STYLE_DOT,1);
SetIndexBuffer (3,Buf_3);
//SetIndexStyle (1,DRAW_LINE,STYLE_SOLID,2);
return(INIT_SUCCEEDED);  
//---
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
  {
//---
  
  if(Time[0]>nullbar) //  
  {
   newbar=true;
   nullbar=Time[0];
  }else
  {
   newbar=false;
  }
  

      
      PerTF="PERIOD_M15"; //    
      PerTFm="PERIOD_M5"; //    

   
   int i, Counted_bars; // 
   i = rates_total-prev_calculated-1;//   
   while(i>=0)
   {
    Buf_0[i]=iMA(Symbol(),PerTF,PerMa1,ma_shift,ma_method,applied_price,i); //  0   i- 
    Buf_1[i]=iMA(Symbol(),PerTF,PerMa2,ma_shift,ma_method,applied_price,i); //  1   i- 
    Buf_2[i]=iMA(Symbol(),PerTFm,PerMa1,ma_shift,ma_method,applied_price,i); //  2   i- 
    Buf_3[i]=iMA(Symbol(),PerTFm,PerMa2,ma_shift,ma_method,applied_price,i); //  3   i- 
    i--; //    
   }
     
   //Print("0 bistr=",Buf_0[0],", 0 medl=",Buf_1[0],", 1 bistr=",Buf_0[1],", 1 medl=",Buf_1[1],", vishemast=",vishemast,", nigemast=",nigemast);
  if(newbar==true) //   
  { 
   if(Buf_0[1]<=Buf_1[1])
   {
      if(Buf_0[0]>Buf_1[0])
      {
         if(Bid>Buf_1[0] || Bid>Buf_0[0])
         {
            vishemast = true;
            nigemast = false;
            Alert("  !");
         }
      }
   }
   if(Buf_0[1]>=Buf_1[1])
   {
      if(Buf_0[0]<Buf_1[0])
      {
         if(Bid<Buf_1[0] || Bid<Buf_0[0])
         {
            vishemast = false;
            nigemast = true;
            Alert("  !");
         }
      }
   }
  }  
  
  //Print(Buf_2[0]," - Buf_2[0]",Buf_3[0]," - Buf_3[0]",Buf_2[1]," - Buf_2[1]",Buf_3[1]," - Buf_3[1]");
 
   if(Buf_2[1]>=Buf_3[1])
   {
      if(Buf_2[0]<Buf_3[0])
      {
         if(Bid<Buf_2[0] || Bid<Buf_3[0])
         {
            Alert("   !");
         }
      }
   }

 
   if(Buf_2[1]<=Buf_3[1])
   {
      if(Buf_2[0]>Buf_3[0])
      {
         if(Bid>Buf_2[0] || Bid>Buf_3[0])
         {
            Alert("   !");
         }
      }
   }

//--- return value of prev_calculated for next call
   return(rates_total);

//+------------------------------------------------------------------+
 }
 
